#include <vector>
#include <vector>
#include <fstream>
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <string>
#include <set>
#include <math.h>
#include <map>
#include <queue>
using namespace std;
int main() {
	int n, m, k;
	cin >> n >> m >> k;
	vector <vector <int>> g(n, vector <int>(0));
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	vector <vector <int>> v(k, vector <int>(2));
	for (int i = 0; i < k; i++) {
		int a, b;
		cin >> a >> b;
		v[i][0] = a - 1;
		v[i][1] = b;
	}
	int sum = 0;
	set <pair <int, int>> s;
	vector <int> r(n, -1);
	for (int i = 0; i < k; i++) {
		int a;
		a = v[i][0];
		r[a] = v[i][1];
		s.insert({ -r[a],a });
	}
	vector <int> used(n, 0);
	while (s.size() > 0) {
		int ve = (*(s.begin())).second;
		int b = r[ve];
		used[ve] = 1;
		s.erase({ -r[ve], ve });
		if (b == 0) {
			break;
		}
		if (b > 0) {
			//cout << ve << " " << a << endl;
			for (int i = 0; i < g[ve].size(); i++) {
				int u = g[ve][i];
				if (used[u] == 0 || r[u] < r[ve] - 1) {
					s.erase({ -r[u], u });
					s.insert({ -r[ve] + 1, u });
					used[u] = 1;
				}
				r[u] = max(r[u], r[ve] - 1);
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (used[i] == 1) {
			sum++;
		}
	}
	cout << sum << endl;
	for (int i = 0; i < n; i++) {
		if (used[i] == 1) {
			cout << i + 1 << " ";
		}
	}
	return 0;
}
